unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm3 = class(TForm)
    PaintBox1: TPaintBox;
    pole_width: TEdit;
    pole_height: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    player_type: TLabel;
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const cell_width=10;    // 
      cell_height=10;  // 

var
  Form3: TForm3;
  main_array:array of array of integer; //  
  isgame:boolean;  //  
  player_one:boolean;    //  
  xcount,ycount:integer; //   

implementation

{$R *.dfm}
procedure sum_recheck;
var i,j,k:integer;
    sum_one,sum_two,sum:integer;   //  , , 
begin
sum_one:=0;
sum_two:=0;
//   
for  i:=0 to xcount-1 do
begin
sum:=0;// 
for j := 0 to ycount - 1 do
  begin
    sum:=sum+main_array[i,j];// 
  end;
if sum mod 2 =1 then sum_two:=sum_two+sum   //       
else sum_one:=sum_one+sum; //   
end;
// ,   
for  j:=0 to ycount-1 do
begin
sum:=0;
for i := 0 to xcount - 1 do
  begin
    sum:=sum+main_array[i,j];
  end;
if sum mod 2 =1 then sum_two:=sum_two+sum
else sum_one:=sum_one+sum;
end;
//  (  )
if xcount>ycount then k:=ycount else k:=xcount;
sum:=0;
//   
for i := 0 to k - 1 do
  sum:=sum+main_array[i,i];

if sum mod 2 =1 then sum_two:=sum_two+sum
else sum_one:=sum_one+sum;
//     
if sum_one>sum_two then
showmessage('  "0"')
else if sum_two>sum_one then
    showmessage('  "1"')
    else showmessage('''');
end;

procedure recheck;
var i,j:integer;
    ind:boolean;
begin
ind:=false;
//   
for i := 0 to xcount - 1 do
for j := 0 to ycount-1 do
if main_array[i,j]=-1 then ind:=true;
if ind=false then 
sum_recheck;
end;

procedure TForm3.Button1Click(Sender: TObject);
var i,j:integer;
begin
// 
xcount:=strtoint(pole_width.Text);// 
ycount:=strtoint(pole_height.Text);// 
setlength(main_array,xcount,ycount);//   
//    (   "-1")
for i := 0 to xcount - 1 do
  for j := 0 to ycount - 1 do
  main_array[i,j]:=-1;
isgame:=true;//   
player_one:=true;//  
paintbox1.Repaint;// 
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
setlength(main_array,0,0);
isgame:=false;
end;

procedure TForm3.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i,j:integer;
    ind:boolean;
begin
if isgame=true then //   
begin
//   
i:=x div cell_width;
j:=y div cell_height;
ind:=false;
//     ,   
if i>=xcount then ind:=true;
if j>=ycount then ind:=true;
if ind = false then
//  ,   ,     
if main_array[i,j]=-1 then//        
if player_one=true then
begin
main_array[i,j]:=0;
player_type.caption:='  "1"';
end
else
begin
main_array[i,j]:=1;
player_type.caption:='  "0"';
end;
player_one:=not player_one;// 

paintbox1.Repaint;// 

recheck;// 
end;
end;
// 
procedure TForm3.PaintBox1Paint(Sender: TObject);
var i,j:integer;
begin
paintbox1.Canvas.Pen.Color:=clred;
for i := 0 to xcount do
begin
paintbox1.Canvas.MoveTo(i*cell_width,0);
paintbox1.Canvas.LineTo(i*cell_width,ycount*cell_height);
end;

for j := 0 to ycount do
begin
paintbox1.Canvas.MoveTo(0,j*cell_height);
paintbox1.Canvas.LineTo(xcount*cell_width+1,j*cell_height);
end;

for i := 0 to xcount - 1 do
for j := 0 to ycount-1 do
begin
if main_array[i,j]=0 then
begin
paintbox1.Canvas.Brush.Color:=clgreen;
paintbox1.Canvas.FillRect(bounds(i*cell_width,j*cell_height,cell_width,cell_height));
end;
if main_array[i,j]=1 then
begin
paintbox1.Canvas.Brush.Color:=clyellow;
paintbox1.Canvas.FillRect(bounds(i*cell_width,j*cell_height,cell_width,cell_height));
end;

end;

  
end;

end.
